//
//  KJScrollView.swift
//  13-绘图
//
//  Created by apple on 2017/9/11.
//  Copyright © 2017年 HEJJY. All rights reserved.
//

import UIKit

let KDisplayCount = 7 // 每页显示的数量

class KJScrollView: UIScrollView {
    
    var xWidth : CGFloat = 0
    var drawWidth : CGFloat = 0
    
    var drawInfos : [KJDrawInfo] = [KJDrawInfo]()

    
    init(frame: CGRect, drawInfos : [KJDrawInfo]) {
        super.init(frame: frame)
        
        backgroundColor = UIColor.white
        self.bounces = false
        self.showsHorizontalScrollIndicator = false
        self.showsVerticalScrollIndicator = false
        self.delegate = self
        self.drawInfos = drawInfos
        
        addSubviews()
    }
    
    func addSubviews() {
        
        calculationScrollViewContentSize()
        
        let drawView = KJDrawView(frame: CGRect(x: 0, y: 0, width: drawWidth, height: self.height), drawInfos: drawInfos, xWidth: xWidth)
        
        addSubview(drawView)

        if drawInfos.count > KDisplayCount {
            
            self.contentOffset = CGPoint(x: drawWidth - self.width, y: 0)
        }
    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
        
        
    }
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    
    // Only override draw() if you perform custom drawing.
    // An empty implementation adversely affects performance during animation.
    override func draw(_ rect: CGRect) {
        
    }

}

extension KJScrollView : UIScrollViewDelegate {
    
    func scrollViewDidScroll(_ scrollView: UIScrollView) {
        
        print("\(scrollView.contentOffset.x)")
    }
}

extension KJScrollView {
    
    func calculationScrollViewContentSize() {
        
        if drawInfos.count <= KDisplayCount {
            
            xWidth = (KScreenW - 80) / (CGFloat)(KDisplayCount - 1)
            self.contentSize = CGSize(width: self.width, height: self.height)
            drawWidth = self.width
            
        } else {
            
            xWidth = (KScreenW - 80) / (CGFloat)(KDisplayCount - 1)
            self.contentSize = CGSize(width: self.width + xWidth * (CGFloat)(drawInfos.count - KDisplayCount) , height: self.height)
            drawWidth = self.width + xWidth * (CGFloat)(drawInfos.count - KDisplayCount)
        }
    }
}
